#require "hbhpdf"


PROCEDURE Main( cFileToSave )

   SETMODE( 50, 128 )
   CLS

   IF Empty( cFileToSave )
      cFileToSave := "myharu.pdf"
      FERASE( cFileToSave )
   ENDIF

   IF DesignHaruPDF( cFileToSave )
      Alert( "PDF File <" + cFileToSave + "> is created!" )
      hb_RUN( cFileToSave )
   ELSE
      Alert( "Some problems in creating the PDF!" )
   ENDIF

   RETURN

FUNCTION DesignHaruPDF( cFileToSave )

   LOCAL page, height, width, def_font, tw
   LOCAL page_title := "hbhpdf demo áàãâä Παρακαλώ ΠΑΡΑΚΑΛΩ"
   LOCAL oFont

   LOCAL pdf := HPDF_New()

   IF pdf == NIL
      Alert( "PDF could not be created!" )
      RETURN NIL
   ENDIF

   /* Enable Unicode */
   HPDF_UseUTFEncodings( pdf )
   oFont := HPDF_LoadTTFontFromFile( pdf, "Arial.ttf", .T. )

   /* set compression mode */
   HPDF_SetCompressionMode( pdf, HPDF_COMP_ALL )

   page := HPDF_AddPage( pdf )
   height := HPDF_Page_GetHeight( page )
   width  := HPDF_Page_GetWidth( page )

   /* Print the lines of the page. */
   HPDF_Page_SetLineWidth( page, 1 )
   HPDF_Page_Rectangle( page, 50, 50, width - 100, height - 110 )
   HPDF_Page_Stroke( page )

   /* Print the title of the page(with positioning center). */
   def_font := HPDF_GetFont( pdf, oFont, "UTF-8" ) // HPDF_GetFont( pdf, "Helvetica", "WinAnsiEncoding" /* 'UTF-8' */ )

   HPDF_Page_SetFontAndSize( page, def_font, 24 )
   tw := HPDF_Page_TextWidth( page, page_title )
   HPDF_Page_BeginText( page )
   HPDF_Page_TextOut( page, ( width - tw ) / 2, height - 50, page_title )
   HPDF_Page_EndText( page )

   IF HPDF_SaveToFile( pdf, cFileToSave ) != 0
      ? "0x" + hb_NumToHex( HPDF_GetError( pdf ), 4 ), hb_HPDF_GetErrorString( HPDF_GetError( pdf ) ), HPDF_GetErrorDetail( pdf )
   ENDIF

   HPDF_Free( pdf )

   RETURN hb_FileExists( cFileToSave )
